//========================================================================================
//
//	File:				FWBndShp.h
//	Release Version:	$ 1.0d1 $
//
//	Creation Date:		3/28/94
//
//	Copyright:	 1993, 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWBNDSHP_H
#define FWBNDSHP_H

#ifndef FWSHAPE_H
#include "FWShape.h"
#endif

#ifndef FWRECT_H
#include "FWRect.h"
#endif

#ifndef FWINK_H
#include "FWInk.h"
#endif

#ifndef FWSTYLE_H
#include "FWStyle.h"
#endif

// ----- Foundation Includes -----

#ifndef FWSTDDEF_H
#include <FWStdDef.h>
#endif

//========================================================================================
//	 Forward Declarations
//========================================================================================

class XMPTransform;

//========================================================================================
//	 class FW_CBoundedShapeRep
//========================================================================================

class FW_CBoundedShapeRep : public FW_CShapeRep
{
//----------------------------------------------------------------------------------------
//	 Constructors/Destructors
//
protected:
	FW_CBoundedShapeRep();
	FW_CBoundedShapeRep(const FW_SDefaultProperties& defaultProperties, const FW_CRect& rect);
	
	virtual ~FW_CBoundedShapeRep();
	
//----------------------------------------------------------------------------------------
//	 Inherited API
//
public:
	// ----- Hit Testing -----
	virtual FW_HitTestPart HitTest(const FW_CPoint& test) const;

	// ----- Transform -----
	virtual void	Transform(XMPTransform* transform);
	virtual void	InverseTransform(XMPTransform* transform);

	virtual void	MoveShape(XMPCoordinate deltaX, XMPCoordinate deltaY);
	virtual void	MoveShapeTo(XMPCoordinate x, XMPCoordinate y);

	// ----- Geometry -----
	virtual FW_CRect GetShapeBounds() const;

	// ----- Stream -----
	virtual void	Flatten(FW_CWritableStream& stream);
	virtual void	Unflatten(FW_CReadableStream& stream);

//----------------------------------------------------------------------------------------
//	 New API
//
public:
	FW_CRect		GetRectangle() const
						{return fRect;}	
	void			SetRectangle(const FW_CRect& rect)
						{fRect = rect; Changed();}
						
//----------------------------------------------------------------------------------------
//	 Data Members
//
protected:
	FW_CRect		fRect;	
};

#endif